require './Pessoa.rb'
require './PessoaFisica.rb'
require './PessoaJuridica.rb'
require './ClienteFisico.rb'
require './ClienteJuridico.rb'
require './Fornecedor.rb'
require './Produto.rb'
require './Compra.rb'
require './Venda.rb'

def mostrarArray(data)
	data.each do |a|
		puts a.to_str	
	end
end

def lerArquivo(arg, file, data)
	file = File.new(file, "r")
	line = file.gets
	while (line = file.gets)
		array = line.split(';')

		if arg == '-c' 
			if array[5] == 'F'
				data.push(ClienteFisico.new(array[0], array[1], array[2], array[3], array[6], array[4]))
			else
				data.push(ClienteJuridico.new(array[0], array[1], array[2], array[3], array[6], array[7], array[4]))
			end
		elsif arg == '-f'
			data.push(Fornecedor.new(array[0], array[1], array[2], array[3], array[4], '-', array[5]))
		elsif arg == '-p'
			array[4] = array[4].gsub(',', '.').to_f
			data.push(Produto.new(array[0], array[4].to_f, array[5]))
		elsif arg == '-a'
			data.push(Compra.new(array[1], array[3], array[4]))
		elsif arg == '-v'
			if array[4] == "F\n" || array[4] == 'F'
				data.push(Venda.new(array[0], array[2], array[3], array[4]))
			end
		end
	end
	file.close
end

## MINI BANCO DE DADOS
clientes = Array.new()
fornecedores = Array.new()
produtos = Array.new()
compras = Array.new()
vendas = Array.new()

###########################################
#LEITURA DOS ARGUMENTOS
arquivo = 0
argumento = 'a'
ARGV.each do |a|
	if arquivo == 0
		argumento = a
	end
	case argumento
	when '-c'
		if arquivo == 1
			lerArquivo(argumento, a, clientes)
			arquivo = 0
		else
			arquivo += 1
		end
	when '-f'
		if arquivo == 1
			lerArquivo(argumento, a, fornecedores)
			arquivo = 0
		else
			arquivo += 1
		end
	when '-p'
		if arquivo == 1
			lerArquivo(argumento, a, produtos)
			arquivo = 0
		else
			arquivo += 1
		end
	when '-a'
		if arquivo == 1
			lerArquivo(argumento, a, compras)
			arquivo = 0
		else
			arquivo += 1
		end
	when '-v'
		if arquivo == 1
			lerArquivo(argumento, a, vendas)
			arquivo = 0
		else
			arquivo += 1
		end
	end

end
###########################################

def setarAPagar(fornecedores, compras, produtos)
	fornecedores.each do |fornecedor|
		compras.each do |compra|
			if compra.getFornecedor == fornecedor.getCodigo
				produtos.each do |produto|
					if compra.getProduto == produto.getCodigo
						fornecedor.setAPagar(produto.getCusto.to_f * compra.getQuantidade.to_f)
					end
				end
			end
		end
	end
end

def setarAReceber(clientes, vendas, produtos)
	vendas.each do |venda|
		clientes.each do |cliente|
			if cliente.getCodigo == venda.getCliente
				produtos.each do |produto|
					if venda.getProduto == produto.getCodigo
						cliente.setAPagar(produto.getCusto.to_f * (produto.getLucro.to_f/100 + 1) * venda.getQuantidade.to_f)
					end
				end
			end	
		end
	end

end

def exportarAPagar(fornecedores)
	a = File.open("1-apagar.csv", "w") do |file|
		file.puts "Fornecedor;CNPJ;Pessoa de contato;Telefone;Total a pagar"

		fornecedores.each do |a|		
			file.puts a.getNome + ';' + a.getCnpj + ';' + a.getContato.chop + ';' + a.getTelefone + ';R$ ' + a.getAPagar.round(2).to_s
		end
	end
end

def exportarAReceber(clientes)
	a = File.open("2-areceber.csv", "w") do |file|
		file.puts "Nome;Tipo;CPF/CNPJ;Telefone;Data de cadastro;Total a pagar"

		clientes.each do |a|
			if a.instance_of? ClienteJuridico
				file.puts a.getNome + ';J;' + a.getCnpj + ';' + a.getTelefone + ';' + a.getData + ';R$ ' + a.getAPagar.round(2).to_s
			else
				file.puts a.getNome + ';F;' + a.getCpf + ';' + a.getTelefone + ';' + a.getData + ';R$ ' + a.getAPagar.round(2).to_s
			end				
		end
	end
end

#ORDENA OS ARRAYS
fornecedores.sort! { |a,b| a.getNome.downcase <=> b.getNome.downcase }
clientes.sort! { |a,b| a.getNome.downcase <=> b.getNome.downcase }

#SETA OS VALORES DE A PAGAR E A RECEBER
setarAPagar(fornecedores, compras, produtos)
setarAReceber(clientes, vendas, produtos)

#EXPORTA OS DADOS
exportarAPagar(fornecedores)
exportarAReceber(clientes)